
extern string AUTHOR = "ok1990@126.com";
extern int MAGIC = 90903;
extern double LOTS = 0.01;
extern bool BUY = true;
extern bool SELL = true;
extern string _ = "set STEP=200 for 5 decimals price broker";
extern int STEP = 20;
extern string __ = "set TPALL=1000 for 5 decimals price broker";
extern int TPALL = 100;

string s_target = "eurchf-h1-target";
double last_bars;
double last_target = -1;
double last_make = -1;
bool g_shutdown = false;

int init() 
{
   if (last_make<0) last_make = 0;
   if (last_target<0) {
      last_target = GlobalVariableGet(s_target);
      if (last_target<0) last_target = 10*LOTS*MarketInfo(Symbol(), MODE_TICKVALUE);
   } 
   return (0);
}

int start()
{
   int i,cnt=0;
   double tp = 0;
   for (i=0; i<OrdersTotal(); i++) {
      if (!OrderSelect(i, SELECT_BY_POS)) return (0);
      if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC && OrderCloseTime()<=0) {
         tp = tp+OrderProfit()+OrderCommission()+OrderSwap();
         cnt ++;
         if (g_shutdown) OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 1, Yellow);
      }
   }
   if (g_shutdown) {
      if (cnt>0) return (0);
      if (cnt==0) g_shutdown = false;
   }
     
   if (tp+last_make>last_target) {      
      for (i=0; i<OrdersTotal(); i++) {
         OrderSelect(i, SELECT_BY_POS);
         if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC && OrderCloseTime()<=0) {
            OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 1, Yellow);
         }
      }
      g_shutdown = true;
      last_target = 0;
      last_make = 0;
      return (0);
   }
   if (cnt==0 && last_target<=0) {
      last_target = TPALL*LOTS*MarketInfo(Symbol(), MODE_TICKVALUE);
      last_make = 0;
      GlobalVariableSet(s_target, last_target);
   }   
   
   double hh = iHigh(Symbol(), 0, iHighest(Symbol(), 0, MODE_HIGH, 4, 1));
   double ll = iLow(Symbol(), 0, iLowest(Symbol(), 0, MODE_LOW, 4, 1));
   double last_buy=10000;
   double last_sell=-10000;
   for (i=OrdersTotal()-1; i>=0; i--) {
      if (!OrderSelect(i, SELECT_BY_POS)) return (0);
      if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC && OrderCloseTime()<=0) {
         if (OrderType()==OP_BUY && OrderOpenPrice()<last_buy) last_buy = OrderOpenPrice();
         if (OrderType()==OP_SELL && OrderOpenPrice()>last_sell) last_sell = OrderOpenPrice();
      }
   } 
   if (Ask<ll) {  
      for (i=OrdersTotal()-1; i>=0; i--) {
         OrderSelect(i, SELECT_BY_POS);
         tp = OrderProfit()+OrderCommission()+OrderSwap();
         if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC && OrderCloseTime()==0) {
            if (OrderType()==OP_SELL && tp>0) {         
               if (OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 0)) {
                  last_make = last_make+tp;
               }
            } 
         }
      }
      if (last_bars!=Bars && last_buy-Ask>STEP*Point && BUY) {
         if (OrderSend(Symbol(), OP_BUY, LOTS, Ask, 0, 0, 0, "", MAGIC, Blue)>0) last_bars = Bars;
      }
   }
   if (Bid>hh) {  
      for (i=OrdersTotal()-1; i>=0; i--) {
         OrderSelect(i, SELECT_BY_POS);
         tp = OrderProfit()+OrderCommission()+OrderSwap();
         if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC && OrderCloseTime()==0) {
            if (OrderType()==OP_BUY && tp>0) {         
               if (OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 0)) {
                  last_make = last_make+tp;
               }   
            } 
         }
      }
      if (last_bars!=Bars && Bid-last_sell>STEP*Point && SELL) {
         if (OrderSend(Symbol(), OP_SELL, LOTS, Bid, 0, 0, 0, "", MAGIC, Red)>0) last_bars = Bars;
      }
   }   
   
   return (0);
}





























